;##################################################################
; EXCEPT GOASM
;##################################################################
#include "Except.Inc"

;#include "\RadASM\GoAsm\inc\debug.a"
;DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
;DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists 

/*
EXAMPLE OUTPUT

Module name: Except.exe
Windows 2000 Service Pack 4
Exception code: C0000094h
EXCEPTION_INT_DIVIDE_BY_ZERO
Instruction pointer: 00401016h

Registers:
eax=0000000Ah ebx=7FFDF000h ecx=00000000h
edx=000A0000h esi=00000005h edi=C0000000h
ebp=0012FFF0h esp=0012FFC4h eip=00401016h

Segment registers:
CS=001Bh DS=0023h SS=0023h
ES=0023h FS=0038h GS=0000h

Flags: PF ZF IF

Stack:
7C5987E7 C0000000 00000005 7FFDF000
C0000094 0012FFC8 0012FC18 FFFFFFFF
7C5C1BB4 7C572B00 00000000 00000000
00000000 00401000 00000000 000000C8
*/

MODULEINFO struct
	lpBaseOfDll	DD
	SizeOfImage	DD
	EntryPoint	DD
ENDS

.code
Start:
	; You must include the following 2 lines
	invoke SetUnhandledExceptionFilter,OFFSET FinalHandler
	invoke InitHyperLinkClass

	mov eax,10
	xor ecx,ecx
	div ecx

	invoke ExitProcess,0

	; Add the following to your code:
.const
	HLM_SETTYPE			equ	WM_USER+200 ; lParam = HLINK_URL/HLINK_EMAIL wndxtra 0
	HLM_SETHOTCOLOR		equ	WM_USER+201 ; lParam = Hot color wndxtra 4
	HLM_SETTEXTCOLOR	equ	WM_USER+202 ; lParam = Normal text color wndxtra 8
	HLM_SETSUBJECT		equ	WM_USER+203 ; lParam = Email subject line wndxtra 24
	HLM_SETBODY			equ	WM_USER+204 ; lParam = Email body wndxtra 28
	HLM_SETUNDERLINE	equ	WM_USER+205 ; lParam = Underline link TRUE/FALSE wndxtra 32
	HLM_SETLINK			equ	WM_USER+206	; lParam = Hyperlink URL wndxtra 36
	HLINK_URL			equ	0
	HLINK_EMAIL			equ	1

.code

FinalHandler FRAME pExceptInfo
	uses esi,edi,ebx
	LOCAL buffer[512]		:B
	LOCAL szBody[512]		:B
	LOCAL osvi				:OSVERSIONINFO

	; Clear the direction flag just in case
	cld

	/*
	Clean up any things here, like freeing memory and handles
	*/

	mov B[buffer],0
	mov B[szBody],0

	mov eax,[pExceptInfo]
	mov edi,[eax+EXCEPTION_POINTERS.pExceptionRecord]
	mov esi,[eax+EXCEPTION_POINTERS.ContextRecord]

	mov D[osvi.dwOSVersionInfoSize],SIZEOF OSVERSIONINFO
	invoke GetVersionEx,ADDR osvi
	mov eax,VER_PLATFORM_WIN32_WINDOWS
	and eax,D[osvi.dwPlatformId]
	jz >.NT
	invoke FindModuleByAddr9x,[edi+EXCEPTION_RECORD.ExceptionAddress],OFFSET buffer
	jmp >
	.NT
	invoke FindModuleByAddrNT,[edi+EXCEPTION_RECORD.ExceptionAddress],OFFSET buffer
	:
	invoke wsprintf,OFFSET szBody,OFFSET szModuleFmt,OFFSET buffer
	add esp,12

	cmp D[osvi.dwMajorVersion],4
	jne >>.XP2K
		cmp D[osvi.dwMinorVersion],0
		jne >
			cmp D[osvi.dwPlatformId],VER_PLATFORM_WIN32_WINDOWS
			jne >.NT4
				invoke wsprintf,OFFSET buffer,offset szOSVersion1,\
					OFFSET osvi.szCSDVersion
				add esp,12
				jmp >>.OSVERSION
			.NT4
				invoke wsprintf,OFFSET buffer,offset szOSVersion5,\
					OFFSET osvi.szCSDVersion
				add esp,12
				jmp >>.OSVERSION
		:
		cmp D[osvi.dwMinorVersion],10
		jne >
			invoke wsprintf,OFFSET buffer,offset szOSVersion2,\
				OFFSET osvi.szCSDVersion
			add esp,12
			jmp >>.OSVERSION
		:
		cmp D[osvi.dwMinorVersion],90
		jne >
			invoke wsprintf,OFFSET buffer,offset szOSVersion3,\
				OFFSET osvi.szCSDVersion
			add esp,12
			jmp >>.OSVERSION
		:
	.XP2K
	cmp D[osvi.dwMajorVersion],5
	jne >>.OTHER
		cmp D[osvi.dwMinorVersion],0
		jne >
			invoke wsprintf,OFFSET buffer,offset szOSVersion6,\
				OFFSET osvi.szCSDVersion
			add esp,12
			jmp >>.OSVERSION
		:
		cmp D[osvi.dwMinorVersion],1
		jne >
			invoke wsprintf,OFFSET buffer,offset szOSVersion7,\
				OFFSET osvi.szCSDVersion
			add esp,12
			jmp >.OSVERSION
		:
		cmp D[osvi.dwMinorVersion],2
		jne >
			invoke wsprintf,OFFSET buffer,offset szOSVersion8,\
				OFFSET osvi.szCSDVersion
			add esp,12
			jmp >.OSVERSION
		:
	jmp >.OSVERSION
	.OTHER
	; Other
		invoke wsprintf,offset buffer,offset szOSVersion0,\
			[osvi.dwMajorVersion],[osvi.dwMinorVersion],OFFSET osvi.szCSDVersion
		add esp,20
	.OSVERSION
	invoke lstrcat,OFFSET szBody,offset buffer

	invoke GetExcptText,[edi+EXCEPTION_RECORD.ExceptionCode]
	mov edx,[edi+EXCEPTION_RECORD.ExceptionAddress]

	invoke wsprintf,OFFSET buffer,OFFSET szExcCodeFmt,\
		[edi+EXCEPTION_RECORD.ExceptionCode],eax,edx
	add esp,16

	invoke lstrcat,OFFSET szBody,OFFSET buffer
	invoke wsprintf, OFFSET buffer, OFFSET szRegsFmt, [esi+CONTEXT.regEax],\
		[esi+CONTEXT.regEbx], [esi+CONTEXT.regEcx], [esi+CONTEXT.regEdx],\
		[esi+CONTEXT.regEsi], [esi+CONTEXT.regEdi], [esi+CONTEXT.regEbp],\
		[esi+CONTEXT.regEsp], [esi+CONTEXT.regEip]
	add esp,44

  /*Using my format you can control all the cpu regs and know what they were
  when you started your code and what processor does to them as things progress
  Even microsoft debugger dos version does not update DS and a few other regs
  as you go, i guess they figure you dont need to know or you would buy the books
  ,but what would the books be called, possible names might be, what is my Ds reg doing
  these days, or doing now,another name might be why cant i get to see my Ds reg
  after update via processor action?
  the micro processor gets to see it waaaaaannnnnnnnn :( annnnnnn annnnnnnnn
  
  Seriously:
  If you dont know exactly what every reg is at from begining to end it's best to code
  in some high level language where it does not matter to the coder, what argument
  can some one give me, and I quote "yu yuu you really dont have to know what DS is"
  ahahahaaaaaahahahahaaaaaa
  do what i did below for all your regs if this does not pan out to be actual
  reading why did they design the code to begin with, yes machine language
  is first and assembler second, if the machine regs dont pan out, dont wonder
  why your code is a big mess of misplaced pointers, pointing to the moon instead
  of where they should be pointing to... {this should help tons in understanding
  what the CPU is doing with every line of your code VERBATUM !!! yyyyaaaaaaayyy
  :) i tucked a little note pad thingy in da folder for you, the guy who designed
  it said i dont care what you do with my nPad enjoy so im giving you a copy of it
  . it's got cool features ,like line numbers and can color code a bunch of kinds
  of code, java, sql, c++, etc...
  
  anyone interested in coding a Software Micro Processor, just imagine
  it could run any code on earth as long as you have the equates table for each
  op-code, would be fun to run some mac stuff on the dell here with just
  a software micro processor to do all the hard work...
  
  ;My updates to this code begins at line 217, there are 2 lines of updated
  ;code,dont forget to turn the line numbers on ,"it's the red Check thingy"
  ;We are going to need those Eflags and status regs Donkey "hehaw hehawww"
  ;and anything that has to do with zero page regs we need it badly so we can
  ;wail up some super coding stuff
  
  */
  
  mov ax,0002h                     ;thatsahmasin added this
  mov [esi+CONTEXT.regDs],ax     ;thatsahmasin added this
	invoke lstrcat,OFFSET szBody,OFFSET buffer
	invoke wsprintf,OFFSET buffer,OFFSET szSegFmt,[esi+CONTEXT.regCs],\
		[esi+CONTEXT.regDs],[esi+CONTEXT.regSs],[esi+CONTEXT.regEs],\
		[esi+CONTEXT.regFs],[esi+CONTEXT.regGs]

	add esp,32

	invoke lstrcat,OFFSET szBody,offset buffer

	invoke BuildFlagString,OFFSET buffer,[esi+CONTEXT.regFlag]
	invoke lstrcat,OFFSET szBody,OFFSET buffer

	invoke StackDump,OFFSET szBody,[esi+CONTEXT.regEsp]

	invoke GetModuleHandle,0
	invoke DialogBoxParam,eax,1000,0,OFFSET ErrorDlgProc,OFFSET szBody

	mov eax,EXCEPTION_EXECUTE_HANDLER
	ret

	szOSVersion0:		db	"Windows %u.%u %s",13,10,0
	szOSVersion1:		db	"Windows 95 %s",13,10,0
	szOSVersion2:		db	"Windows 98 %s",13,10,0
	szOSVersion3:		db	"Windows ME %s",13,10,0
	szOSVersion5:		db	"Windows NT4 %s",13,10,0
	szOSVersion6:		db	"Windows 2000 %s",13,10,0
	szOSVersion7:		db	"Windows XP %s",13,10,0
	szOSVersion8:		db	"Windows 2003 %s",13,10,0

	szModuleFmt:		db	"Module name: %s",13,10,0

	szExcCodeFmt:		db	"Exception code: %Xh",13,10,"%s",13,10,\
							"Instruction pointer: %0.8Xh",13,10,13,10,0

	szRegsFmt:			db	"Registers:",13,10,\
							"eax=%0.8Xh ebx=%0.8Xh ecx=%0.8Xh",13,10,\
							"edx=%0.8Xh esi=%0.8Xh edi=%0.8Xh",13,10,\
							"ebp=%0.8Xh esp=%0.8Xh eip=%0.8Xh",13,10,\
							13,10,0

	szSegFmt:			db	"Segment registers:",13,10,\
							"CS=%0.4Xh DS=%0.4Xh SS=%0.4Xh",13,10,\
							"ES=%0.4Xh FS=%0.4Xh GS=%0.4Xh",13,10,\
							13,10,0

ENDF

BuildFlagString FRAME pString,eflagdata
	uses edi

	invoke lstrcpy,[pString],"Flags: "
	mov edi,[pString]
	add edi,6

	mov B[edi],0
	mov eax,[eflagdata]
	bt eax,0
	jnc >
	mov D[edi]," CF"
	add edi,3
	:
	bt eax,2
	jnc >
	mov D[edi]," PF"
	add edi,3
	:
	bt eax,4
	jnc >
	mov D[edi]," AF"
	add edi,3
	:
	bt eax,6
	jnc >
	mov D[edi]," ZF"
	add edi,3
	:
	bt eax,7
	jnc >
	mov D[edi]," SF"
	add edi,3
	:
	bt eax,8
	jnc >
	mov D[edi]," TF"
	add edi,3
	:
	bt eax,9
	jnc >
	mov D[edi]," IF"
	add edi,3
	:
	bt eax,10
	jnc >
	mov D[edi]," DF"
	add edi,3
	:
	bt eax,11
	jnc >
	mov D[edi]," OF"
	add edi,3
	:
	mov B[edi],13
	mov B[edi+1],10
	mov B[edi+2],0

	RET
ENDF

FindModuleByAddr9x FRAME Address,pModuleName
	LOCAL pID						:D
	LOCAL hSnap						:D
	LOCAL me32						:MODULEENTRY32
	LOCAL hlib						:D
	LOCAL pCreateToolhelp32Snapshot	:D
	LOCAL pModule32First			:D
	LOCAL pModule32Next				:D

	mov D[me32.dwSize],SIZEOF MODULEENTRY32

	invoke LoadLibrary,"Kernel32.dll"
	or eax,eax
	jnz >
	ret
	:
	mov [hlib],eax
	invoke GetProcAddress,[hlib],"CreateToolhelp32Snapshot"
	mov [pCreateToolhelp32Snapshot],eax
	invoke GetProcAddress,[hlib],"Module32First"
	mov [pModule32First],eax
	invoke GetProcAddress,[hlib],"Module32Next"
	mov [pModule32Next],eax

	invoke lstrcpy,[pModuleName],"undetermined"
	invoke GetCurrentProcessId
	mov [pID],eax

	push [pID]
	push TH32CS_SNAPMODULE
	call [pCreateToolhelp32Snapshot]
	mov [hSnap],eax

	push offset me32
	push [hSnap]
	call [pModule32First]
	jmp >L2
	L1:
		mov eax,[me32.modBaseAddr]
		mov ecx,[me32.modBaseSize]
		add ecx,eax
		cmp [Address],eax
		jb >
		cmp [Address],ecx
		ja >
		invoke lstrcpy,[pModuleName],OFFSET me32.szModule
		jmp >.DONE
		:
		push offset me32
		push [hSnap]
		call [pModule32Next]
		L2:
		or eax,eax
		jnz <L1
	.DONE
	invoke CloseHandle,[hSnap]

	invoke FreeLibrary,[hlib]
	RET
ENDF

FindModuleByAddrNT FRAME Address,pModuleName
	uses edi,esi,ebx
	LOCAL pID					:D
	LOCAL hProcess				:D
	LOCAL hMods[1024]			:D
	LOCAL cbNeeded				:D
	LOCAL modinfo				:MODULEINFO
	LOCAL hModule				:D
	LOCAL hlib					:D
	LOCAL pEnumProcessModules	:D
	LOCAL pGetModuleInformation	:D
	LOCAL ModName[MAX_PATH]		:B

	invoke LoadLibrary,"psapi.dll"
	or eax,eax
	jnz >
	ret
	:
	mov [hlib],eax
	invoke GetProcAddress,[hlib],"EnumProcessModules"
	mov [pEnumProcessModules],eax
	invoke GetProcAddress,[hlib],"GetModuleInformation"
	mov [pGetModuleInformation],eax

	invoke lstrcpy,[pModuleName],"undetermined"
	mov ebx,[Address]
	invoke GetCurrentProcessId
	mov [pID],eax
	invoke OpenProcess,PROCESS_QUERY_INFORMATION+PROCESS_VM_READ,FALSE,[pID]
	mov [hProcess],eax

	push offset cbNeeded
	push 1024
	push offset hMods
	push [hProcess]
	call [pEnumProcessModules]
	or eax,eax
	jz >>.DONE
		mov edi,[cbNeeded]
		shr edi,2
		mov esi,offset hMods
		L1:
		mov eax,[esi]
		mov [hModule],eax
		add esi,4

		push SIZEOF MODULEINFO
		push offset modinfo
		push [hModule]
		push [hProcess]
		call [pGetModuleInformation]
		or eax,eax
		jz >.DONE
		cmp ebx,[modinfo.lpBaseOfDll]
		jg >L2
			dec edi
			or edi,edi
			js >.DONE
			jmp <L1
		L2:
			mov eax,[modinfo.SizeOfImage]
			add eax,[modinfo.lpBaseOfDll]
			cmp ebx,eax
			jl >L3
			dec edi
			or edi,edi
			js >.DONE
			jmp <L1
		L3:
		invoke GetModuleFileName,[hModule],OFFSET ModName,256
		invoke GetFileTitle,OFFSET ModName,[pModuleName],256

	.DONE
	invoke CloseHandle,[hProcess]
	invoke FreeLibrary,[hlib]
	RET
ENDF

StackDump FRAME pOutString,pStack
	uses edi,esi

	invoke lstrlen,[pOutString]
	mov edi,eax
	add edi,[pOutString]
	mov esi,[pStack]
	mov ecx,15
	:
		mov eax,ecx
		shl eax,2
		push [esi+eax]
		dec ecx
		jns <

	push offset szStackFmt
	push edi
	call wsprintf
	add esp,72

	RET
	szStackFmt:		db	13,10,"Stack:",13,10,\
						"%0.8X %0.8X %0.8X %0.8X",13,10,\
						"%0.8X %0.8X %0.8X %0.8X",13,10,\
						"%0.8X %0.8X %0.8X %0.8X",13,10,\
						"%0.8X %0.8X %0.8X %0.8X",0
ENDF

ErrorDlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,esi,ebx

	cmp D[uMsg],WM_INITDIALOG
	jne >>.WMCOMMAND
		invoke LoadIcon,NULL,IDI_ERROR
		invoke SendDlgItemMessage,[hwnd],1006,STM_SETICON,eax,0
		invoke SendDlgItemMessage,[hwnd],1004,WM_SETFONT,NULL,TRUE
		invoke SendDlgItemMessage,[hwnd],1005,WM_SETFONT,NULL,TRUE
		invoke CreateFontIndirect,OFFSET DisplayFont
		invoke SendDlgItemMessage,[hwnd],1003,WM_SETFONT,eax,TRUE
		invoke SendDlgItemMessage,[hwnd],1003,WM_SETTEXT,0,[lParam]

		; Set up hyperlink
		invoke SendDlgItemMessage,[hwnd],1001,WM_SETTEXT,0,"Report this error"
		invoke SendDlgItemMessage,[hwnd],1001,HLM_SETLINK,0,"donkey@visualassembler.com"
		invoke SendDlgItemMessage,[hwnd],1001,HLM_SETHOTCOLOR,0,0FF0000h
		invoke SendDlgItemMessage,[hwnd],1001,HLM_SETTEXTCOLOR,0,0
		invoke SendDlgItemMessage,[hwnd],1001,HLM_SETTYPE,0,HLINK_EMAIL
		invoke SendDlgItemMessage,[hwnd],1001,HLM_SETSUBJECT,0,"Exception report"
		invoke SendDlgItemMessage,[hwnd],1001,HLM_SETBODY,0,[lParam]
		invoke SendDlgItemMessage,[hwnd],1001,HLM_SETUNDERLINE,0,TRUE
		jmp >>.EXIT

	.WMCOMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WMCLOSE
		movzx eax,W[wParam]
		cmp eax,1002
		jne >.EXIT
			invoke PostMessage,[hwnd],WM_CLOSE,0,0
		jmp >.EXIT

	.WMCLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		invoke SendDlgItemMessage,[hwnd],1003,EM_SETSEL,0,-1
		invoke SendDlgItemMessage,[hwnd],1003,WM_COPY,0,0
		invoke SendDlgItemMessage,[hwnd],1003,WM_GETFONT,0,0
		invoke DeleteObject,eax
		invoke EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret

	; LOGFONT structure
	DisplayFont:	DD	-11,0,0,0,FW_NORMAL
					DB	FALSE,FALSE,0,0,0,0,0,0
					DB	"Courier new",0

ENDF

GetExcptText FRAME ExCode
	mov eax, [ExCode]
	:
	cmp eax,0C0000005h ; EXCEPTION_ACCESS_VIOLATION
	jne >
		push "EXCEPTION_ACCESS_VIOLATION"
		pop eax
		jmp >>.exit
	:
	cmp eax,0C000008Ch ;EXCEPTION_ARRAY_BOUNDS_EXCEEDED
	jne >
		push "EXCEPTION_ARRAY_BOUNDS_EXCEEDED"
		pop eax
		jmp >>.exit
	:
	cmp eax,080000003h ;EXCEPTION_BREAKPOINT
	jne >
		push "EXCEPTION_BREAKPOINT"
		pop eax
		jmp >>.exit
	:
	cmp eax,080000002h ;EXCEPTION_DATATYPE_MISALIGNMENT
	jne >
		push "EXCEPTION_DATATYPE_MISALIGNMENT"
		pop eax
		jmp >>.exit
	:
	cmp eax,0C000008Dh ;EXCEPTION_FLT_DENORMAL_OPERAND
	jne >
		push "EXCEPTION_FLT_DENORMAL_OPERAND"
		pop eax
		jmp >>.exit
	:
	cmp eax,0C000008Eh ;EXCEPTION_FLT_DIVIDE_BY_ZERO
	jne >
		push "EXCEPTION_FLT_DIVIDE_BY_ZERO"
		pop eax
		jmp >>.exit
	:
	cmp eax,0C000008Fh ;EXCEPTION_FLT_INEXACT_RESULT
	jne >
		push "EXCEPTION_FLT_INEXACT_RESULT"
		pop eax
		jmp >>.exit
	:
	cmp eax,0C0000090h ;EXCEPTION_FLT_INVALID_OPERATION
	jne >
		push "EXCEPTION_FLT_INVALID_OPERATION"
		pop eax
		jmp >.exit
	:
	cmp eax,0C0000091h ;EXCEPTION_FLT_OVERFLOW
	jne >
		push "EXCEPTION_FLT_OVERFLOW"
		pop eax
		jmp >.exit
	:
	cmp eax,0C0000092h ;EXCEPTION_FLT_STACK_CHECK
	jne >
		push "EXCEPTION_FLT_STACK_CHECK"
		pop eax
		jmp >.exit
	:
	cmp eax,0C0000093h ;EXCEPTION_FLT_UNDERFLOW
	jne >
		push "EXCEPTION_FLT_UNDERFLOW"
		pop eax
		jmp >.exit
	:
	cmp eax,0C000001Dh ;EXCEPTION_ILLEGAL_INSTRUCTION
	jne >
		push "EXCEPTION_ILLEGAL_INSTRUCTION"
		pop eax
		jmp >.exit
	:
	cmp eax,0C0000006h ;EXCEPTION_IN_PAGE_ERROR
	jne >
		push "EXCEPTION_IN_PAGE_ERROR"
		pop eax
		jmp >.exit
	:
	cmp eax,0C0000094h ;EXCEPTION_INT_DIVIDE_BY_ZERO
	jne >
		push "EXCEPTION_INT_DIVIDE_BY_ZERO"
		pop eax
		jmp >.exit
	:
	cmp eax,0C0000095h ;EXCEPTION_INT_OVERFLOW
	jne >
		push "EXCEPTION_INT_OVERFLOW"
		pop eax
		jmp >.exit
	:
	cmp eax,080000004h ;EXCEPTION_SINGLE_STEP
	jne >
		push "EXCEPTION_SINGLE_STEP"
		pop eax
		jmp >.exit
	:
		push "UNKNOWN_EXCEPTION"
		pop eax
	.exit
	ret
endf

; Hyperlink code is reusable

_Hyperlink FRAME hlc_hWin,hlc_uMsg,hlc_wParam,hlc_lParam
	LOCAL hlc_tme				:TRACKMOUSEEVENT
	LOCAL hlc_ps				:PAINTSTRUCT
	LOCAL hlc_hdc				:D
	LOCAL hlc_strlen			:D
	LOCAL hlc_prc				:RECT
	LOCAL hlc_color				:D
	LOCAL hlc_pt				:POINT
	LOCAL hlc_text[2048]		:B
	LOCAL hlc_pSubject			:D

	cmp D[hlc_uMsg],WM_SETTEXT
	jne >>.WM_CREATE
		; Get the border size
		invoke GetWindowRect,[hlc_hWin],ADDR hlc_prc
		mov eax,[hlc_prc.right]
		sub eax,[hlc_prc.left]
		push eax
		mov eax,[hlc_prc.bottom]
		sub eax,[hlc_prc.top]
		push eax
		invoke GetClientRect,[hlc_hWin],ADDR hlc_prc
		pop eax
		sub eax,[hlc_prc.bottom]
		pop ecx
		push eax
		sub ecx,[hlc_prc.right]
		push ecx

		invoke GetDC,[hlc_hWin]
		mov [hlc_hdc],eax

		invoke GetWindowLong,[hlc_hWin],20
		or eax,eax
		jnz >
			invoke GetStockObject,SYSTEM_FONT
		:
		invoke SelectObject,[hlc_hdc],eax
		invoke lstrlen,[hlc_lParam]
		invoke DrawText,[hlc_hdc],[hlc_lParam],eax,ADDR hlc_prc,DT_CALCRECT
		pop ecx
		add ecx,[hlc_prc.right]
		sub ecx,[hlc_prc.left]

		pop eax
		add eax,[hlc_prc.bottom]
		sub eax,[hlc_prc.top]
		invoke SetWindowPos,[hlc_hWin],HWND_TOP,0,0,ecx,eax,SWP_NOMOVE or SWP_NOZORDER
		invoke ReleaseDC,[hlc_hWin],[hlc_hdc]
		jmp >>.DONE

	.WM_CREATE
	cmp D[hlc_uMsg],WM_CREATE
	jne >>.HLM_SETTYPE
		invoke GlobalAlloc,GPTR,4192
		invoke SetWindowLong,[hlc_hWin],12,eax
		jmp >>.DONE

	.HLM_SETTYPE
	cmp D[hlc_uMsg],HLM_SETTYPE
	jne >.HLM_SETUNDERLINE
		invoke SetWindowLong,[hlc_hWin],0,[hlc_lParam]
		ret

	.HLM_SETUNDERLINE
	cmp D[hlc_uMsg],HLM_SETUNDERLINE
	jne >.HLM_SETHOTCOLOR
		invoke SetWindowLong,[hlc_hWin],32,[hlc_lParam]
		ret

	.HLM_SETHOTCOLOR
	cmp D[hlc_uMsg],HLM_SETHOTCOLOR
	jne >>.HLM_SETTEXTCOLOR
		invoke SetWindowLong,[hlc_hWin],4,[hlc_lParam]
		; set the current color if necessary
		invoke GetCursorPos,ADDR hlc_pt
		invoke GetParent,[hlc_hWin]
		push eax
		mov ecx,eax
		invoke ScreenToClient,ecx,ADDR hlc_pt
		pop ecx
		invoke ChildWindowFromPoint,ecx,[hlc_pt.x],[hlc_pt.y]
		cmp eax,[hlc_hWin]
		jne >
			invoke SetWindowLong,[hlc_hWin],16,[hlc_lParam]
			mov D[hlc_tme.cbSize],SIZEOF TRACKMOUSEEVENT
			mov D[hlc_tme.dwFlags],TME_LEAVE
			mov eax,[hlc_hWin]
			mov [hlc_tme.hwndTrack],eax
			mov D[hlc_tme.dwHoverTime],HOVER_DEFAULT
			invoke _TrackMouseEvent,ADDR hlc_tme
		:
		invoke InvalidateRect,[hlc_hWin],NULL,TRUE
		invoke UpdateWindow,[hlc_hWin]
		ret

	.HLM_SETTEXTCOLOR
	cmp D[hlc_uMsg],HLM_SETTEXTCOLOR
	jne >>.HLM_SETSUBJECT
		invoke SetWindowLong,[hlc_hWin],8,[hlc_lParam]
		; set the current color if necessary
		invoke GetCursorPos,ADDR hlc_pt
		invoke GetParent,[hlc_hWin]
		push eax
		mov ecx,eax
		invoke ScreenToClient,ecx,ADDR hlc_pt
		pop ecx
		invoke ChildWindowFromPoint,ecx,[hlc_pt.x],[hlc_pt.y]
		cmp eax,[hlc_hWin]
		je >
			invoke SetWindowLong,[hlc_hWin],16,[hlc_lParam]
		:
		invoke InvalidateRect,[hlc_hWin],NULL,TRUE
		invoke UpdateWindow,[hlc_hWin]
		ret

	.HLM_SETSUBJECT
	cmp D[hlc_uMsg],HLM_SETSUBJECT
	jne >>.HLM_SETLINK
		invoke lstrlen,[hlc_lParam]
		inc eax
		mov [hlc_strlen],eax
		invoke GetWindowLong,[hlc_hWin],24
		mov [hlc_pSubject],eax
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GlobalAlloc,GPTR,[hlc_strlen]
		mov [hlc_pSubject],eax
		cmp D[hlc_strlen],1024
		jl >
			mov eax,[hlc_lParam]
			add eax,1023
			mov B[eax],0
		:
		invoke lstrcpy,[hlc_pSubject],[hlc_lParam]
		invoke SetWindowLong,[hlc_hWin],24,[hlc_pSubject]
		ret

	.HLM_SETLINK
	cmp D[hlc_uMsg],HLM_SETLINK
	jne >>.HLM_SETBODY
		invoke lstrlen,[hlc_lParam]
		inc eax
		mov [hlc_strlen],eax
		invoke GetWindowLong,[hlc_hWin],36
		mov [hlc_pSubject],eax
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GlobalAlloc,GPTR,[hlc_strlen]
		mov [hlc_pSubject],eax
		cmp D[hlc_strlen],1024
		jl >
			mov eax,[hlc_lParam]
			add eax,1023
			mov B[eax],0
		:
		invoke lstrcpy,[hlc_pSubject],[hlc_lParam]
		invoke SetWindowLong,[hlc_hWin],36,[hlc_pSubject]
		ret

	.HLM_SETBODY
	cmp D[hlc_uMsg],HLM_SETBODY
	jne >>.WM_SETFONT
		invoke lstrlen,[hlc_lParam]
		inc eax
		mov [hlc_strlen],eax
		invoke GetWindowLong,[hlc_hWin],28
		mov [hlc_pSubject],eax
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GlobalAlloc,GPTR,[hlc_strlen]
		mov [hlc_pSubject],eax
		cmp D[hlc_strlen],1024
		jl >
			mov eax,[hlc_lParam]
			add eax,1023
			mov B[eax],0
		:
		invoke lstrcpy,[hlc_pSubject],[hlc_lParam]
		invoke SetWindowLong,[hlc_hWin],28,[hlc_pSubject]
		ret

	.WM_SETFONT
	cmp D[hlc_uMsg],WM_SETFONT
	jne >.WM_LBUTTONDOWN
		; The def window proc does not do fonts so it has to be done manually
		invoke SetWindowLong,[hlc_hWin],20,[hlc_wParam]
		invoke GetWindowText,[hlc_hWin],ADDR hlc_text,256
		invoke SetWindowText,[hlc_hWin],ADDR hlc_text
		mov eax,[hlc_lParam]
		or eax,eax
		jz >
			invoke InvalidateRect,[hlc_hWin],NULL,TRUE
			invoke UpdateWindow,[hlc_hWin]
		:
		ret

	.WM_LBUTTONDOWN
	cmp D[hlc_uMsg],WM_LBUTTONDOWN
	jne >>.WM_MOUSEMOVE
		invoke GetWindowLong,[hlc_hWin],12
		mov [hlc_pSubject],eax

		invoke GetWindowLong,[hlc_hWin],0
		cmp eax,HLINK_URL
		jne >B1
			invoke GetWindowLong,[hlc_hWin],36
			mov [hlc_pSubject],eax
			invoke lstrlen,eax
			jnz >
				invoke GetWindowText,[hlc_hWin],[hlc_pSubject],256
			:
		B1:
		cmp eax,HLINK_EMAIL
		jne >>B2
			invoke GetWindowLong,[hlc_hWin],36
			mov ebx,eax
			invoke lstrlen,ebx
			jnz >
				xor ebx,ebx
			:
			invoke lstrcpy,[hlc_pSubject],OFFSET hlc_szMailTo
			mov eax,[hlc_pSubject]
			add eax,7
			or ebx,ebx
			jz >
				invoke lstrcpy,eax,ebx
				jmp >B0
			:
				invoke GetWindowText,[hlc_hWin],eax,240
			B0:
			invoke GetWindowLong,[hlc_hWin],24
			or eax,eax
			jz >>B2
				push eax
				invoke lstrcat,[hlc_pSubject],OFFSET hlc_szSubject
				pop eax
				mov D[hlc_strlen],2048
				invoke lstrcat,[hlc_pSubject],eax
				invoke GetWindowLong,[hlc_hWin],28
				or eax,eax
				jz >B2
				push eax
				invoke lstrcat,[hlc_pSubject],OFFSET hlc_szBody
				pop eax
				invoke lstrcat,[hlc_pSubject],eax
		B2:
		invoke FormatURL,[hlc_pSubject],OFFSET hlc_text,TRUE
		invoke ShellExecute, [hlc_hWin], OFFSET hlc_szOpen,OFFSET hlc_text, 0, 0, SW_SHOWNORMAL
		jmp >>.DONE

	.WM_MOUSEMOVE
	cmp D[hlc_uMsg],WM_MOUSEMOVE
	jne >>.WM_MOUSELEAVE
		; The first mouse move message changes the color
		invoke GetWindowLong,[hlc_hWin],4
		push eax
		invoke SetWindowLong,[hlc_hWin],16,eax
		pop ecx
		cmp eax,ecx
		je >>.DONE
			mov D[hlc_tme.cbSize],SIZEOF TRACKMOUSEEVENT
			mov D[hlc_tme.dwFlags],TME_LEAVE
			mov eax,[hlc_hWin]
			mov [hlc_tme.hwndTrack],eax
			mov D[hlc_tme.dwHoverTime],HOVER_DEFAULT
			invoke _TrackMouseEvent,ADDR hlc_tme
			invoke InvalidateRect,[hlc_hWin],NULL,TRUE
		jmp >>.DONE

	.WM_MOUSELEAVE
	cmp D[hlc_uMsg],WM_MOUSELEAVE
	jne >.WM_PAINT
		invoke GetWindowLong,[hlc_hWin],8
		invoke SetWindowLong,[hlc_hWin],16,eax
		invoke InvalidateRect,[hlc_hWin],NULL,TRUE
		ret

	.WM_PAINT
	cmp D[hlc_uMsg],WM_PAINT
	jne >>.WM_DESTROY
		invoke GetWindowText,[hlc_hWin],ADDR hlc_text,256
		mov [hlc_strlen],eax
		invoke GetWindowLong,[hlc_hWin],16
		mov [hlc_color],eax
		invoke BeginPaint,[hlc_hWin],ADDR hlc_ps
			mov [hlc_hdc],eax
			invoke GetWindowLong,[hlc_hWin],20
			invoke SelectObject,[hlc_hdc],eax
			invoke SetTextColor,[hlc_hdc],[hlc_color]
			invoke GetSysColor,COLOR_3DFACE
			invoke SetBkMode,[hlc_hdc],TRANSPARENT
			invoke TextOut,[hlc_hdc],0,0,ADDR hlc_text,[hlc_strlen]

			invoke GetWindowLong,[hlc_hWin],32 ; Underline
			or eax,eax
			jz >>
				; a line is drawn
				invoke CreatePen,PS_SOLID,1,[hlc_color]
				invoke SelectObject,[hlc_hdc],eax
				push eax
				invoke GetClientRect,[hlc_hWin],ADDR hlc_prc
				dec D[hlc_prc.bottom]
				invoke MoveToEx,[hlc_hdc],0,[hlc_prc.bottom],NULL
				invoke LineTo,[hlc_hdc],[hlc_prc.right],[hlc_prc.bottom]
				pop eax
				invoke SelectObject,[hlc_hdc],eax
				invoke DeleteObject,eax
			:

		invoke EndPaint,[hlc_hWin],ADDR hlc_ps
		ret

	.WM_DESTROY
	cmp D[hlc_uMsg],WM_DESTROY
	jne >.DONE
		invoke GetWindowLong,[hlc_hWin],12
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GetWindowLong,[hlc_hWin],24
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GetWindowLong,[hlc_hWin],28
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GetWindowLong,[hlc_hWin],36
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:

	.DONE
	invoke DefWindowProc,[hlc_hWin],[hlc_uMsg],[hlc_wParam],[hlc_lParam]
	ret

	hlc_szMailTo: 	db		"mailto:",0
	hlc_szSubject:	db		"?subject=",0
	hlc_szBody:		db		"&body=",0
	hlc_szOpen:		db		"open",0

ENDF

InitHyperLinkClass FRAME
	LOCAL hlc_wcx			:WNDCLASSEX

	mov D[hlc_wcx.cbSize],SIZEOF WNDCLASSEX
	mov D[hlc_wcx.style], CS_HREDRAW + CS_VREDRAW
	invoke GetModuleHandle,NULL
	mov D[hlc_wcx.hInstance],eax
	mov D[hlc_wcx.lpszClassName],OFFSET UDC_HyperClass
	mov D[hlc_wcx.cbClsExtra],0
	mov D[hlc_wcx.cbWndExtra],40
	mov D[hlc_wcx.lpfnWndProc],OFFSET _Hyperlink
	mov D[hlc_wcx.hIcon],NULL
	mov D[hlc_wcx.hIconSm],NULL
	invoke GetStockObject,NULL_BRUSH
	mov D[hlc_wcx.hbrBackground],eax
	mov D[hlc_wcx.lpszMenuName],NULL

	invoke LoadCursor,NULL,IDC_HAND
	mov [hlc_wcx.hCursor],eax

	invoke RegisterClassEx,ADDR hlc_wcx

	ret

	UDC_HyperClass:	db		"UDC_HyperLink",0
ENDF

FormatURL FRAME pString,pOutString,DoPercent
	uses ebx,esi,edi
	mov edi,[pOutString]
	mov esi,[pString]
	mov ebx,[DoPercent]

	L0:
	mov al,[esi]
	cmp al,0
	je >>.DONE

	; Chars
	cmp al,"a"
	jb >
	cmp al,"z"
	jbe >.NORMAL
	:
	cmp al,"A"
	jb >
	cmp al,"Z"
	jbe >.NORMAL
	:
	cmp al,"0"
	jb >
	cmp al,"9"
	jbe >.NORMAL
	:

	; Allowed
	cmp al,"-"
	je >.NORMAL
	cmp al,"_"
	je >.NORMAL
	cmp al,"."
	je >.NORMAL
	cmp al,"!"
	je >.NORMAL
	cmp al,"-"
	je >.NORMAL
	cmp al,"*"
	je >.NORMAL
	cmp al,27h
	je >.NORMAL
	cmp al,"("
	je >.NORMAL
	cmp al,")"
	je >.NORMAL

	; Reserved
	cmp al,";"
	je >.NORMAL
	cmp al,"/"
	je >.NORMAL
	cmp al,"?"
	je >.NORMAL
	cmp al,":"
	je >.NORMAL
	cmp al,"@"
	je >.NORMAL
	cmp al,"&"
	je >.NORMAL
	cmp al,"="
	je >.NORMAL
	cmp al,"+"
	je >.NORMAL
	cmp al,"$"
	je >.NORMAL
	cmp al,","
	je >.NORMAL

	.REPLACE
	cmp al,"%"
	jne >
	or ebx,ebx
	jz >.NORMAL
	:
	movzx edx,al
	invoke wsprintf,edi,"%%%0.2X",edx
	add esp,12
	add edi,3
	inc esi
	jmp <<L0

	.NORMAL
	movsb
	jmp <<L0
	
	.DONE
	mov B[edi],0
	ret
ENDF
